% Load data
load SWmat1.txt 
load SWmat2.txt 
load SWmat3.txt 
load SWmat4.txt
matrix=[SWmat1 SWmat2 SWmat3 SWmat4];
[n,m]=size(matrix);

% DRI database explanation of the series in the columns of matrix "matrix"

% sa = seasonally adjusted
% nsa = not seasonally adjusted
% saar = seasonally adjusted at an annual rate
% frb = federal reserve board data
% ac = Stock and Watson's own calculations
meaning=...
    {...%Real output and income
    'industrial production: total index (1992=100, sa)';...
        'industrial production: products, total (1992=100, sa)';...
        'industrial production: final products (1992=100, sa)';...
        'industrial production: consumer goods (1992=100, sa)';...
        'industrial production: durable consumer goods (1992=100, sa)';...
        'industrial production: nondurable consumer goods (1992=100, sa)';...
        'industrial production: business equipment (1992=100, sa)';...
        'industrial production: intermediate products (1992=100, sa)';...
        'industrial production: materials (1992=100, sa)';...
        'industrial production: durable goods materials (1992=100, sa)';...
        'industrial production: nondurable goods materials (1992=100, sa)';...
        'industrial production: manufacturing (1992=100, sa)';...
        'industrial production: durable manufacturing (1992=100, sa)';...
        'industrial production: non-durable manufacturing (1992=100, sa)';...
        'industrial production: mining (1992=100, sa)';...
        'industrial production: utilities (1992-=100, sa)';...
        'capacity utilization rate: total industry (% of capacity, sa) (frb)';...
        'capacity utilization rate: manufacturing, total (% of capacity, sa) (frb)';...
        'capacity utilization rate: durable manufacturing (% of capacity, sa) (frb)';...
        'capacity utilization rate: nondurable manufacturing (% of capacity, sa) (frb)';...
        'capacity utilization rate: mining (% of capacity, sa) (frb)';...
        'capacity utilization rate: utilities (% of capacity, sa) (frb)';...
        'purchasing managers index (sa)';...
        'NAPM production index (percent)';...
        'personal income (chained) (series #52)(bil 92$,saar)';...
        'personal income less transfer payments (chained) (#51)(bil. 92$,saar)';...
        ...%Employment and hours
        'index of help-wanted advertising in newspapers (1967=100;sa)';...
        'employment; ratio; help-wanted ads:no. unemployed clf';...
        'civilian labor force: employed, total (thous.,sa)';...
        'civilian labor force: employed, nonagric industries (thous.,sa)';...
        'unemployment rate: all workers, 16 years & over (%,sa)';...
        'unemployment by duration: average duration in weeks (sa)';...
        'unemployment by duration: persons unemployed less than 5 wks (thous.,sa)';...
        'unemployment by duration: persons unemployed 5 to 14 wks (thous.,sa)';...
        'unemployment by duration: persons unemployed 15 wks + (thous.,sa))';...
        'unemployment by duration: persons unemployed 15 to 26 wks(thous.,sa)';...
        'employees on nonag. payrolls: total (thous.,sa)';...
        'employees on nonag. payrolls: total, private (thous.,sa)';...
        'employees on nonag. payrolls: goods-producing (thous.,sa)';...
        'employees on nonag. payrolls: mining (thous.,sa)';...
        'employees on nonag. payrolls: contract construction (thous.,sa)';...
        'employees on nonag. payrolls: manufacturing (thous.,sa)';...
        'employees on nonag. payrolls: durable goods (thous.,sa)';...
        'employees on nonag. payrolls: nondurable goods (thous.,sa)';...
        'employees on nonag. payrolls: service-producing (thous.,sa)';...
        'employees on nonag. payrolls: trans. & public utilities (thous.,sa)';...
        'employees on nonag. payrolls: wholesale and retail trade (thous.,sa)';...
        'employees on nonag. payrolls: finance, insur.& real estate (thous.,sa)';...
        'employees on nonag. payrolls: services (thous.,sa)';...
        'employees on nonag. payrolls: government (thous.,sa)';...
        'avg. weekly hours of prod. wkrs.: total private (sa)';...
        'avg. weekly hours of prod. wkrs.: manufacturing (sa)';...
        'avg. weekly hours of prod. wkrs.: mfg.,overtime hrs. (sa)';...
        'NAPM employment index (percent)';...
        ...%Real retail,manufacturing and trade sales
        'manufacturing and trade: total (mil of chained 1992$)(sa)';...
        'manufacturing and trade: mfg,total (mil of chained 1992$)(sa)';...
        'manufacturing and trade: mfg, durable goods (mil of chained 1992$)(sa)';...
        'manufacturing and trade: mfg, nondurable goods(mil of chained 1992$)(sa)';...
        'merchant wholesalers: total (mil of chained 1992$)(sa)';...
        'merchant wholesalers: durable goods total (mil of chained 1992$)(sa)';...
        'merchant wholesalers: nondurable goods (mil of chained 1992$)(sa)';...
        'retail trade: total (mil of chained 1992$)(sa)';...
        'retail trade: nondurable goods (mil of chained 1992$)(sa)';...
        ...%Consumption
        'personal consumption expend (chained)-total (bil 92$,saar)';...
        'personal consumption expend (chained)-total durables (bil 92$,saar)';...
        'personal consumption expend (chained)-total nondurables(bil 92$,saar)';...
        'personal consumption expend (chained)-total services(bil 92$,saar)';...
        'personal consumption expend (chained)-total new cars(bil 92$,saar)';...
        ...%Housing starts and sales
        'housing starts: nonfarm (1947-58);total farm&nonfarm(1959-)(thous.,sa)';...
        'housing starts: northeast (thous.u.)s.a.';...
        'housing starts: midwest (thous.u.)s.a.';...
        'housing starts: south (thous.u.)s.a.';...
        'housing starts: west (thous.u.)s.a.';...
        'housing authorized: total new priv housing units (thous.,saar)';...
        'houses authorized by build. permits; northeast (thous. u.)sa';...
        'houses authorized by build. permits; midwest (thous. u.)sa';...
        'houses authorized by build. permits; south (thous. u.)sa';...
        'houses authorized by build. permits; west (thous. u.)sa';...
        'new 1-family houses sold during month (thous,saar)';...
        'one-family houses sold: northeast (thous. u., sa)';...
        'one-family houses sold: midwest (thous. u., sa)';...
        'one-family houses sold: south (thous. u., sa)';...
        'one-family houses sold: west (thous. u., sa)';...
        'new 1-family houses, month supply at current sales rate (ratio)';...
        'new 1-family houses for sale at end of month (thous,sa)';...
        'mobile homes: manufacturers shipments (thous of units,saar)';...
        'construct.put in place: total priv & public 1987$(mil$,saar)';...
        'construct.put in place: total priv 1987$(mil$,saar)';...
        'construct.put in place: public 1987$(mil$,saar)';...
        'construct.contracts: commertial and industrial bldgs (mil. sq. ft. floor sp.;sa)';...
        ...%Real inventories and inventory-sales ratios
        'manufacturing & trade inventories: total (mil of chained 1992$)(sa)';...
        'inventories, business, mfg (mil of chained 1992$)(sa)';...
        'inventories, business durables (mil of chained 1992$)(sa)';...
        'inventories, business nondurables (mil of chained 1992$)(sa)';...
        'manufacturing & trade inventories: merchant wholesalers (mil of chained 1992$)(sa)';...
        'manufacturing & trade inventories: retail trade (mil of chained 1992$)(sa)';...
        'ratio for mfg&trade: inventory/sales (chained 1992$,sa)';...
        'ratio for mfg&trade: mfg;inventory/sales (87$,sa)';...
        'ratio for mfg&trade: wholesaler;inventory/sales (87$,sa)';...
        'ratio for mfg&trade: retail trade;inventory/sales (87$,sa)';...
        'NAPM inventories index (percent)';...
        ...%Orders and unfiled orders
        'NAPM new orders index (percent)';...
        'NAPM vendor deliveries index (percent)';...
        'new orders (net)-consumer goods & materials, 1992$ (bci)';...
        'new orders, durable goods industries, 1992$ (bci)';...
        'new orders, nondefense capital goods, 92$ (bci)';...
        'mfg new orders:all manufacturing industries, total (mil $,sa)';...
        'mfg new orders:mfg industries with unfilled orders (mil $,sa)';...
        'mfg new orders:durable goods industries, total (mil $,sa)';...
        'mfg new orders:durable goods industries with unfilled orders (mil $,sa)';...
        'mfg new orders:nondurable goods industries, total (mil $,sa)';...
        'mfg new orders:nondurable goods industries with unfilled orders (mil $,sa)';...
        'mfg unfilled orders:all manufacturing industries, total (mil$sa)';...
        'mfg unfilled orders:durable goods industries, total (mil$sa)';...
        'mfg unfilled orders:nondurable goods industries, total (mil$sa)';...
        'contracts and orders for plant&equipment (bil$,sa)';...
        'contracts and orders for plant&equipment in 1992 $(bci)';...
        ...%Stock prices
        'NYSE common stock price index: composite (12/31/65=50)';...
        'NYSE common stock price index: industrial (12/31/65=50)';...
        'NYSE common stock price index: transportation (12/31/65=50)';...
        'NYSE common stock price index: utility (12/31/65=50)';...
        'NYSE common stock price index: finance (12/31/65=50)';...
        'S&P common stock price index: composite (1941-43=10)';...
        'S&P common stock price index: industrials (1941-43=10)';...
        'S&P common stock price index: capital goods (1941-43=10)';...
        'S&P common stock price index: transportation (1970=10)';...
        'S&P common stock price index: utilities (1941-43=10)';...
        'S&P common stock price index: financial (1970=10)';...
        'S&P common stock: divident yield (% per annum)';...
        'S&P common stock: price-earnings ratio (%,nsa)';...
        'NYSE mkt composition: reptd share vol by size, 5000+ shrs,%';...
        ...%Exchange rates
        'United States effective exchange rate (merm)(index no.)';...
        'foreign exchange rate: Germany (Deutsche mark per US$)';...
        'foreign exchange rate: Switzerland (swiss franc per US$)';...
        'foreign exchange rate: Japan (yen per US$)';...
        'foreign exchange rate: United Kingdom (cents per pound)';...
        'foreign exchange rate: Canada (canadian $ per US$)';...
        ...%Interest rates
        'interest rate: federal funds (effective) (% per annum,nsa) fyff';...
        'interest rate: 90 day commercial paper, (ac) (% per ann,nsa) fycp';...
        'interest rate: US treasury bills,sec mkt,3-mo. (%per ann,nsa) fygm3';...
        'interest rate: US treasury bills,sec mkt,6-mo. (%per ann,nsa) fygm6';...
        'interest rate: US treasury const maturities, 1-yr.(%per ann,nsa) fygt1';...
        'interest rate: US treasury const maturities, 5-yr. (%per ann,nsa) fygt5';...
        'interest rate: US treasury const maturities, 10-yr. (%per ann,nsa) fygt10';...
        'bond yield: moodys aaa corporate (% per annum) fyaaac';...
        'bond yield: moodys baa corporate (% per annum) fybaac';...
        'weighted average foreign interest rate (%,sa)';...
        'secondary market yields on fha mortgages (% per annum) fyfha';...
        'spread fycp-fyff';...
        'spread fygm3-fyff';...
        'spread fygm6-fyff';...
        'spread fygt1-fyff';...
        'spread fygt5-fyff';...
        'spread fygt10-fyff';...
        'spread fyaaac-fyff';...
        'spread fybaac-fyff';...
        'spread fyfha-fyff';...
        ...%Money and credit quantity aggregates
        'money stock: m1(curr,trav.cks,dem dep,other ck-able dep)(bil$,sa)';...
        'money stock: m2(m1+o-nite rps, euro$,g/p&b/d mmmfs$sav&sm time dep)(bil$,sa)';...
        'money stock: m3(m2+ lg time dep, term rp-s&inst only mmmfs)(bil$,sa)';...
        'money stock: l(m3+other liquid assets)(bil$,sa)';...
        'money supply-m2 in 1992$ (bci)';...
        'monetary base, adj for reserve requirement changes(mil$,sa)';...
        'depositary inst reserves:total,adj for reserve req chgs(mil$,sa)';...
        'depositary inst reserves:nonborrow+ext cr,adj res req cgs(mil$,sa)';...
        'loans and sec at all coml banks: total (bil$,sa)';...
        'loans and sec at all coml banks: US gov securities (bil$,sa)';...
        'loans and sec at all coml banks: real estate loans (bil$,sa)';...
        'loans and sec at all coml banks: loans to individuals (bil$,sa)';...
        'loans and sec at all coml banks: loans to nonbank fin inst (bil$,sa)';...
        'commercial and industrial loans outstanding in 1992$ (bci)';...
        'wkly rp lg com-l banks:net change com-l & indust loans (bil$,saar)';...
        'consumer instal.loans:delinquency rate, 30 days&over,(%,sa)';...
        'net change in consumer instal cr: total (mil$,sa)';...
        'net change in consumer instal cr: automobile (mil$,sa)';...
        'net change in consumer instal cr: revolving(mil$,sa)';...
        ...%Price indexes
        'NAPM commodity price index (percent)';...
        'producer price index: finished goods (82=100,sa)';...
        'producer price index: finished consumer goods (82=100,sa)';...
        'producer price index: intermed mat supplies&components (82=100,sa)';...
        'producer price index: crude materials (82=100,sa)';...
        'producer price index: finished goods, excl. foods (82=100,sa)';...
        'producer price index: crude materials less energy (82=100,sa)';...
        'producer price index: crude nonfood materials less energy (82=100,sa)';...
        'index of sensitive material prices (1990=100)(bci-99a)';...
        'cpi-u: all items (82-84=100,sa)';...
        'cpi-u: food and beverages (82-84=100,sa)';...
        'cpi-u: housing (82-84=100,sa)';...
        'cpi-u: apparel&upkeep (82-84=100,sa)';...
        'cpi-u: transportation (82-84=100,sa)';...
        'cpi-u: medical care (82-84=100,sa)';...
        'cpi-u: commodities (82-84=100,sa)';...
        'cpi-u: durables (82-84=100,sa)';...
        'cpi-u: services (82-84=100,sa)';...
        'cpi-u: all items less food (82-84=100,sa)';...
        'cpi-u: all items less shelter(82-84=100,sa)';...
        'cpi-u: all items less medical care(82-84=100,sa)';...
        'commodities price:gold,london noon fix,avg of daly rate,$ per oz';...
        'pce, impl pr defl;pce (1987-100)';...
        'pce, impl pr defl;pce; durables (1987-100)';...
        'pce, impl pr defl;pce;nondurables (1987-100)';...
        'pce, impl pr defl;pce;services (1987-100)';...
        ...%Average hourly earnings
        'avg hr earnings of prod wkrs: total private nonagric ($,sa)';...
        'avg hr earnings of constr wkrs: construction ($,sa)';...
        'avg hr earnings of prod wkrs: manufacturing ($,sa)';...
        'avg hr earnings of nonsupv wkrs: trans&public util ($,sa)';...
        'avg hr earnings of prod wkrs: wholesale&retail trade ($,sa)';...
        'avg hr earnings of nonsupv wkrs: finance,insur,real est($,sa)';...
        'avg hr earnings of nonsupv wkrs: sevices ($,sa)';...
        ...Miscellaneous
        'US mdse exports: total exports (f.a.s. value)(mil $,sa)';...
        'US mdse imports: general imports (c.i.f. value)(mil $,sa)';...
        'US mdse imports: general imports (customs value)(mil $,sa)';...
        'US mdse trade balance: exports less imports (f.a.s./c.i.f.)(mil $,sa)';...
        'US mdse trade balance: exp (fas) less imports (custom)(mil $,sa)';...
        'u.of mich. index of consumer expectations(bcd-83)'};


% Transformation code
tc=[5*ones(16,1);ones(8,1);5*ones(3,1);4;5;5;ones(6,1);...
        5*ones(14,1);2;1;1;1;5*ones(14,1);4*ones(22,1);...
        5*ones(6,1);2;2;2;2;1;1;1;5*ones(25,1);1;1;5*ones(7,1);...
        2*ones(9,1);1;2;ones(9,1);6;6;6;6;5;6;6;6;5*ones(6,1);...
        ones(6,1);6*ones(32,1);5;5;5;2;2;1];
size(tc);

% Create balanced panel from those variables that were
% observed for 1/1/59:12/1/98 (a 480 months long period)
balanced=[];
tcb=[];
include=[];
exclude=[];
for i=1:m
    if max(matrix(1:480,i))<1.00e+32
       balanced=[balanced matrix(1:480,i)];
       tcb=[tcb;tc(i,1)];
       include=[include;i];
   else
       exclude=[exclude;i];
    end
end
[n,m]=size(balanced);
meaningb=meaning(include,1);

% Transform variables according to the transformation code in 'tcb'
for i=1:m
    if tcb(i,1)==1
        tbalanced(:,i)=balanced(3:end,i); %no tranformation
    elseif tcb(i,1)==2
        tbalanced(:,i)=balanced(3:end,i)-balanced(2:end-1,i); %first difference
    elseif tcb(i,1)==4
        tbalanced(:,i)=log(balanced(3:end,i)); %logarithm
    elseif tcb(i,1)==5
        tbalanced(:,i)=log(balanced(3:end,i))-log(balanced(2:end-1,i)); %first diff of logs
    else
        firstdiff=log(balanced(2:end,i))-log(balanced(1:end-1,i));
        tbalanced(:,i)=firstdiff(2:end,1)-firstdiff(1:end-1,1); %second diff of logs
    end
end
[n,m]=size(tbalanced);
        
% Standardize series so they have zero sample mean and 
% unit sample variance
me=mean(tbalanced);
st=std(tbalanced);
stbalanced=(tbalanced-kron(ones(n,1),me))./kron(ones(n,1),st);

% Screen for outliers
percentiles=prctile(stbalanced,[25 50 75]);
interquart=percentiles(3,:)-percentiles(1,:);
upperbound=percentiles(2,:)+10*interquart;
lowerbound=percentiles(2,:)-10*interquart;

notoobig=(max(stbalanced)<upperbound);
notoosmall=(min(stbalanced)>lowerbound);
nooutliers=notoobig.*notoosmall;

bpanel=[];
include1=[];
for i=1:m
    if nooutliers(1,i)==1
        bpanel=[bpanel tbalanced(:,i)];
        include1=[include1;include(i,1)];
    else
        exclude=[exclude;include(i,1)];
    end
end
[n,m]=size(bpanel);
meaning_balanced=meaning(include1,1);

%standardize avaialable data
me=mean(bpanel);
st=std(bpanel);
sbpanel=(bpanel-kron(ones(n,1),me))./kron(ones(n,1),st);
dataclean=sbpanel';