% George Kapetanios' algorithm (translation from Gauss code)
function out1=facesti3(y,k0,maxk,brep,siglev,subb,opt);
% y: data
% maxk: max no. of factors (Kapetanios uses 8)
% brep: Bootstrap no. of reps (Kapetanios uses 99)
% siglev: significance level (Kapetanios uses 0.99. For matlab it is 99)
% subb: subsample proportion (Kapetanios experimented with 0.7, 0.6, 0.5)
% opt: Kapetanios recommends setting it to 2
[t,n]=size(y);
rate=t*((sqrt(t-1)+sqrt(n))^(-1))*((1/sqrt(t-1)+1/sqrt(n))^(-1/3));
c1=bootbon2(y,k0,maxk,brep,subb);
y2=y./kron(std(y),ones(t,1));
opts.disp=0;
meigg=eigs(y2'*y2/t,maxk+1,'la',opts);
tt=rate*(meigg(k0+1,1)-meigg(maxk+1,1));
out1=sum(tt<c1)/brep;
%out1=tt>prctile(c1,siglev);