% This file does some exploration of the BGM data set

load DATA1980-2007Q1_7c_w3
if ~exist('DO_SHORTEN_SAMPLE'),
    DO_SHORTEN_SAMPLE = 0;
end;

if ~exist('DO_PLOT'),
    DO_PLOT = 0;
end;
if ~exist('DO_D_PLOT'),
    DO_D_PLOT = 0;
end;
if ~exist('DO_L_PLOT'),
    DO_L_PLOT = 1;
end;

names1 = [ ...
    '3 mo PIBOR          '
    '10yr gov yield      '
    'Share price         '
    'real exch rate      '
    'GDP deflator        '
    'cons deflator       '
    'GFCF deflator       '
    'exports deflator    '
    'imports deflator    '
    'GDP                 '
    'priv cons expend    '
    'gov cons expend     '
    'gross fixed cap form'
    'exports             '
    'imports             '
    'cap util(Mfg survey)'
    'retail sales (vol.) '
    'passenger cars      '
    'PPI, NSA            '
    'CPI and HICP        '
    'CPI food            '
    'CPI Fuel and Electr '
    'CPI all but food,el.'
    'CPI rent            '
    'civilian employment '
    'unemployment rate   '
    'hourly earnings:Mfg '
    'unit labor costs    '
    'unit labor costs Mfg'
    'unit lab cost constr'
    'unit lab costs serv '
    'M1                  '
    'M3                  ' ];

uselevels1 = [ ...
    1, % '3 mo PIBOR          '
    1, % '10yr gov yield      '
    0, % 'Share price         '
    0, % 'real exch rate      '
    0, % 'GDP deflator        '
    0, % 'cons deflator       '
    0, % 'GFCF deflator       '
    0, % 'exports deflator    '
    0, % 'imports deflator    '
    0, % 'GDP                 '
    0, % 'priv cons expend    '
    0, % 'gov cons expend     '
    0, % 'gross fixed cap form'
    0, % 'exports             '
    0, % 'imports             '
    1, % 'cap util(Mfg survey)'
    0, % 'retail sales (vol.) '
    0, % 'passenger cars      '
    0, % 'PPI, NSA            '
    0, % 'CPI and HICP        '
    0, % 'CPI food            '
    0, % 'CPI Fuel and Electr '
    0, % 'CPI all but food,el.'
    0, % 'CPI rent            '
    0, % 'civilian employment '
    1, % 'unemployment rate   '
    0, % 'hourly earnings:Mfg '
    0, % 'unit labor costs    '
    0, % 'unit labor costs Mfg'
    0, % 'unit lab cost constr'
    0, % 'unit lab costs serv '
    0, % 'M1                  '
    0];% 'M3                  ' ];

countries = [...
    'EU         '
    'Germany    '
    'France     '
    'Italy      '
    'Spain      '
    'Netherlands'
    'Belgium    ' ];

names2 = [ ...
    'FFR                 '
    'Japan Overnight Rate'
    'UK Base Rate        '
    'US 10 yr bond yield '
    'Jap 10 yr bond yield'
    'UK 10 yr bond yield '
    'US GDP              '
    'Japan GDP           '
    'UK GDP              '
    'EuroZone+GR exch rt '
    'Commodity Price indx'
    'Spot Oil Price, $   ' ]; % 232 - 243


uselevels2 = [ ...
    1; % 'FFR                 '
    1; % 'Japan Overnight Rate'
    1; % 'UK Base Rate        '
    1; % 'US 10 yr bond yield '
    1; % 'Jap 10 yr bond yield'
    1; % 'UK 10 yr bond yield '
    0; % 'US GDP              '
    0; % 'Japan GDP           '
    0; % 'UK GDP              '
    0; % 'EuroZone+GR exch rt '
    0; % 'Commodity Price indx'
    0];% 'Spot Oil Price, $   ' ];

uselevels = [ kron(ones(7,1),uselevels1 ) ; uselevels2 ];

time = 1980 : 0.25 : 2007.5;
all = 0 : 33 : 220;


if DO_SHORTEN_SAMPLE,
    T0 = round(interp1(time,1:length(time),1987));
else
    T0 = 1;
end;

sz = size(DATA3);
smpl = max(T0,5) : sz(1);
dtime = time(smpl);
obs=1:length(uselevels);

DDAT = (     ones(length(smpl),1)*uselevels' ) .* DATA3(smpl,obs) + ...
       ( 1 - ones(length(smpl),1)*uselevels' ) .* ( 100*(DATA3(smpl,obs) - DATA3(smpl-4,obs))./DATA3(smpl-4,obs));

LDAT = (     ones(length(smpl),1)*uselevels' ) .* DATA3(smpl,obs) + ...
       ( 1 - ones(length(smpl),1)*uselevels' ) .* ( log(DATA3(smpl,obs)) - log(DATA3(smpl-4,obs)) )*100;

   
L2DAT =(     ones(length(smpl),1)*uselevels' ) .* ( log(1 + DATA3(smpl,obs)/100 ) )*100 + ...
       ( 1 - ones(length(smpl),1)*uselevels' ) .* ( log(DATA3(smpl,obs)) - log(DATA3(smpl-4,obs)) )*100;

lev_std = std(DATA3);
d_std   = std(DDAT); %  + mean(DDAT).^2;
l_std   = std(LDAT);


TSData = DDAT;
TStime = dtime;

sz = size(TSData);
Tmid_ndx = round(interp1(TStime,1:sz(1),1999));
d_std1   = std(DDAT(1 : Tmid_ndx - 1,:));
d_std2   = std(DDAT(Tmid_ndx : sz(1),:));

str1=sprintf('%4.0f',dtime(1));
str2=sprintf('%4.0f',dtime(Tmid_ndx-1));
str3=sprintf('%4.0f',dtime(length(dtime)));

disp('Standard deviations:');
disp(['Variable         Full Sample  ',str1,'-',str2,'   ',str2,'-',str3]);
for j = 1 : 33,
    disp([sprintf('%2.0f: ',j),names1(j,:),' ',sprintf('%5.2f   %5.2f   %5.2f',mean(d_std(j+all)),mean(d_std1(j+all)),mean(d_std2(j+all)))]);
end;

if DO_PLOT,
    plottime = time;
    plotdat  = DATA3;
    titpiece = 'Levels: ';
    plot_std1 = lev_std;
    plot_std2 = plot_std1;
    plotdata;
end;

if DO_D_PLOT,
    plottime = time(smpl);
    plotdat  = DDAT;
    titpiece = 'YOY Growth Rates: ';
    plot_std1 = d_std;
    plot_std2 = plot_std1;
    plotdata;
end;

if DO_L_PLOT,
    plottime = time(smpl);
    plotdat  = LDAT;
    plot_std1 = l_std;
    plot_std2 = plot_std1;
    titpiece = 'YOY Log Differences: ';
    plotdata;
end;
