% This is a new simulation exercise for figure 2

% December 30, 2007
% Set parameters
function [data1,data2]=simulation_figure2_HLBN(n,T,r,vari,theta,ro)
% First, simulate the systematic part of the data
% CASE 1: AR loadings
b0=randn(r*n,1);
b1=0.1*rand(r*n,1)+.8;
b2=0.1*rand(r*n,1)+.5;
% Initialize
SYST=zeros(n,T);
Normaliz=((1+b1.*b2).*b0.^2)./((1-b2.^2).*(1-b1.^2).*(1-b1.*b2));% this is variance of the AR(2)
Norma=zeros(n,1);
for ii=1:r
    syst=zeros(n,2);
    for index=1:(T-2)
        syst(:,2+index)=b0((n*(ii-1)+1):(n*ii),1)*randn(1,1)+(b1((n*(ii-1)+1):(n*ii),1)+...
        b2((n*(ii-1)+1):(n*ii),1)).*syst(:,1+index)-...
        (b1((n*(ii-1)+1):(n*ii),1).*b2((n*(ii-1)+1):(n*ii),1)).*syst(:,index);
    end
    SYST=SYST+syst;
    Norma=Norma+Normaliz((n*(ii-1)+1):(n*ii),1);
end
syst_norm_AR=sqrt(.4+.05*r)*diag(Norma.^(-0.5))*SYST;

% CASE II: MA loadings
b0=randn(r*n,1);
b1=-rand(r*n,1);
b2=-rand(r*n,1);
Normaliz=(b0.^2).*(1+(b1+b2).^2+(b1.*b2).^2);% this is variance of the MA(2)
b1=[b0 -b0.*(b1+b2) b0.*b1.*b2];
factor=randn(r,T+2);
syst=kron(b1(:,1),ones(1,T)).*kron(factor(:,3:end),ones(n,1))+...
    kron(b1(:,2),ones(1,T)).*kron(factor(:,2:end-1),ones(n,1))+...
    kron(b1(:,3),ones(1,T)).*kron(factor(:,1:end-2),ones(n,1));
SYST=zeros(n,T);
NORMA=zeros(n,1);
for ii=1:r
    SYST=SYST+syst((n*(ii-1)+1):(n*ii),:);
    NORMA=NORMA+Normaliz((n*(ii-1)+1):(n*ii),:);
end
syst_norm_MA=sqrt(.4+.05*r)*diag(NORMA.^(-0.5))*SYST;

% Now generate the idiosyncratic terms
v=randn(n,T);
er=v(1,:)/sqrt(1-ro^2);
for j=2:n
er(j,:)=ro*er(j-1,:)+v(j,:);
end
v=sqrt((1-ro^2))*er;%idiosincratic errors
rot=-0.8+1.6*rand(n,1);
er=v(:,1)./sqrt(1-rot.^2);
for j=2:T
er(:,j)=rot.*er(:,j-1)+v(:,j);
end
er=sqrt(.6-.05*r)*kron(sqrt((1-rot.^2)),ones(1,T)).*er;
idios_norm=er;
% Generate data
data1=syst_norm_AR+sqrt(vari)*idios_norm;
data2=syst_norm_MA+sqrt(vari)*idios_norm;