% This is a new simulation exercise for figure 2

% December 30, 2007
% Set parameters
function [out2,data2]=simulation_figure2_discussion(n,T,r,m,theta,ro,q,a,b)
% CASE II: MA loadings
b0=randn(r*n,1);
b1=-rand(r*n,1);
b2=-rand(r*n,1);
Normaliz=(b0.^2).*(1+(b1+b2).^2+(b1.*b2).^2);% this is variance of the MA(2)
b1=[b0 -b0.*(b1+b2) b0.*b1.*b2];
factor=randn(r,T+2);
syst=kron(b1(:,1),ones(1,T)).*kron(factor(:,3:end),ones(n,1))+...
    kron(b1(:,2),ones(1,T)).*kron(factor(:,2:end-1),ones(n,1))+...
    kron(b1(:,3),ones(1,T)).*kron(factor(:,1:end-2),ones(n,1));
SYST=zeros(n,T);
NORMA=zeros(n,1);
for ii=1:r
    SYST=SYST+syst((n*(ii-1)+1):(n*ii),:);
    NORMA=NORMA+Normaliz((n*(ii-1)+1):(n*ii),:);
end
syst_strong_MA=sqrt(r*a)*diag(NORMA.^(-0.5))*SYST;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
b0=randn(q*n,1);
b1=-rand(q*n,1);
b2=-rand(q*n,1);
Normaliz=(b0.^2).*(1+(b1+b2).^2+(b1.*b2).^2);% this is variance of the MA(2)
b1=[b0 -b0.*(b1+b2) b0.*b1.*b2];
factor=randn(q,T+2);
syst=kron(b1(:,1),ones(1,T)).*kron(factor(:,3:end),ones(n,1))+...
    kron(b1(:,2),ones(1,T)).*kron(factor(:,2:end-1),ones(n,1))+...
    kron(b1(:,3),ones(1,T)).*kron(factor(:,1:end-2),ones(n,1));
SYST=zeros(n,T);
NORMA=zeros(n,1);
for ii=1:q
    SYST=SYST+syst((n*(ii-1)+1):(n*ii),:);
    NORMA=NORMA+Normaliz((n*(ii-1)+1):(n*ii),:);
end
syst_weak_MA=sqrt(q*b)*diag(NORMA.^(-0.5))*SYST;

% Now generate the idiosyncratic terms

%g=1+.5*rand(n,5,3);
%v=randn(n+4,T+2);
%for i=1:n
%    for t=1:T
%        idios(i,t)=g(i,:,1)*v(i:i+4,t+2)+g(i,:,2)*v(i:i+4,t+1)+g(i,:,3)*v(i:i+4,t);
%    end
%end
%standarddev=std(idios');
%standdev=diag(standarddev);
v=randn(n,T);
er=v(1,:)/sqrt(1-ro^2);
for j=2:n
er(j,:)=ro*er(j-1,:)+v(j,:);
end
v=sqrt((1-ro^2))*er;%idiosincratic errors
rot=-0.8+1.6*rand(n,1);
er=v(:,1)./sqrt(1-rot.^2);
for j=2:T
er(:,j)=rot.*er(:,j-1)+v(:,j);
end
er=sqrt(1/3)*kron(sqrt((1-rot.^2)),ones(1,T)).*er;
idios_norm=er;
data2=syst_strong_MA+syst_weak_MA+idios_norm;
% Generate frequency domain data
for jjj=1:m
    out2(:,jjj)=data2*(exp(-sqrt(-1)*(1:T)*(theta+2*pi*jjj/T)))';
end
