% This file computes size and power of the test for the of 2 vs 3-7 factors

% sizeX contains actual sizes of the test of nominal sizes xi for AR loadings data
% at frequency range 2*pi*jjj/T with jjj=1:m
% sizeXa contains actual sizes of the test of nominal sizes xi for MA loadings data
% at frequency range 2*pi*jjj/T with jjj=1:m
% sizeY contains actual sizes of the test of nominal sizes xi for AR loadings data
% at frequency range 2*pi*(floor(T/2)-jjj)/T with jjj=1:m
% sizeYa contains actual sizes of the test of nominal sizes xi for MA loadings data
% at frequency range 2*pi*(floor(T/2)-jjj)/T with jjj=1:m

% powerX contains power of the test of nominal sizes xi for AR loadings data
% at frequency range 2*pi*jjj/T with jjj=1:m
% powerXa contains power of the test of nominal sizes xi for MA loadings data
% at frequency range 2*pi*jjj/T with jjj=1:m
% powerY contains power of the test of nominal sizes xi for AR loadings data
% at frequency range 2*pi*(floor(T/2)-jjj)/T with jjj=1:m
% powerYa contains power of the test of nominal sizes xi for MA loadings data
% at frequency range 2*pi*(floor(T/2)-jjj)/T with jjj=1:m




load GUE30K.dat
% Asymptotic distribution of the statistic under the null
R=max((GUE30K(1:5,:)-GUE30K(2:6,:))./(GUE30K(2:6,:)-GUE30K(3:7,:)));
n=150;
T=500;
k=2;
k2=7;
m=65;
opts.disp=0;
for ii=1:8000
    ii 
[X,Xa,Y,Ya]=simulation_figure2_final(n,T,k,m,0,0.2,1);
[X2,X2a,Y2,Y2a]=simulation_figure2_final(n,T,k2,m,0,0.2,1);
evalues=abs(eigs(X'*X,9,'lr',opts));
RX=max((evalues(3:7,1)-evalues(4:8,1))./(evalues(4:8,1)-evalues(5:9,1)));
evalues=abs(eigs(Xa'*Xa,9,'lr',opts));
RXa=max((evalues(3:7,1)-evalues(4:8,1))./(evalues(4:8,1)-evalues(5:9,1)));
evalues=abs(eigs(Y'*Y,9,'lr',opts));
RY=max((evalues(3:7,1)-evalues(4:8,1))./(evalues(4:8,1)-evalues(5:9,1)));
evalues=abs(eigs(Ya'*Ya,9,'lr',opts));
RYa=max((evalues(3:7,1)-evalues(4:8,1))./(evalues(4:8,1)-evalues(5:9,1)));
pvalRX(ii,1)=sum(R>RX)/30000;
pvalRXa(ii,1)=sum(R>RXa)/30000;
pvalRY(ii,1)=sum(R>RY)/30000;
pvalRYa(ii,1)=sum(R>RYa)/30000;
evalues=abs(eigs(X2'*X2,9,'lr',opts));
RX=max((evalues(3:7,1)-evalues(4:8,1))./(evalues(4:8,1)-evalues(5:9,1)));
evalues=abs(eigs(X2a'*X2a,9,'lr',opts));
RXa=max((evalues(3:7,1)-evalues(4:8,1))./(evalues(4:8,1)-evalues(5:9,1)));
evalues=abs(eigs(Y2'*Y2,9,'lr',opts));
RY=max((evalues(3:7,1)-evalues(4:8,1))./(evalues(4:8,1)-evalues(5:9,1)));
evalues=abs(eigs(Y2a'*Y2a,9,'lr',opts));
RYa=max((evalues(3:7,1)-evalues(4:8,1))./(evalues(4:8,1)-evalues(5:9,1)));
pvalRX2(ii,1)=sum(R>RX)/30000;
pvalRX2a(ii,1)=sum(R>RXa)/30000;
pvalRY2(ii,1)=sum(R>RY)/30000;
pvalRY2a(ii,1)=sum(R>RYa)/30000;
end

xi=[0.002;0.004;0.006;0.008;(0.01:0.01:0.99)';0.992;0.994;0.996;0.998];
for i=1:107
    sizeX(i,1)=sum(pvalRX<xi(i))/8000;
    sizeXa(i,1)=sum(pvalRXa<xi(i))/8000;
    sizeY(i,1)=sum(pvalRY<xi(i))/8000;
    sizeYa(i,1)=sum(pvalRYa<xi(i))/8000;
    powerX(i,1)=sum(pvalRX2<xi(i))/8000;
    powerXa(i,1)=sum(pvalRX2a<xi(i))/8000;
    powerY(i,1)=sum(pvalRY2<xi(i))/8000;
    powerYa(i,1)=sum(pvalRY2a<xi(i))/8000;
end

total_result=[sizeX sizeXa sizeY sizeYa powerX powerXa powerY powerYa];