function [freqdata,data]=test_compar_simulation_rev2(n,T,r,m,theta,ro)
% Simulate r-factor approximate factor model
% Systematic part
A=0.85*eye(r);
Factors=randn(r,1)/(1-.85^2);
for i=1:T-1
    a=A*Factors(:,i)+randn(r,1);
    Factors=[Factors a];
end
Lambda=randn(n,r);
SYSTEM=Lambda*Factors;
stdS=kron((std(SYSTEM'))',ones(1,T));
SYSTEM=SYSTEM./stdS;

% idiosyncratic part
roi0=-0.8;
roi1=0.8;
roi=roi0+(roi1-roi0)*rand(n,1);
v=randn(n,T);% initialize
er=v(1,:)/sqrt(1-ro^2);
for j=2:n % Run cross-sectional AR(1) DGP
er(j,:)=ro*er(j-1,:)+v(j,:);
end
v=sqrt((1-ro^2))*er;%idiosincratic errors
er=v(:,1)./sqrt(1-roi.^2);
for j=2:T% Run temporal AR(1) DGP
er(:,j)=roi.*er(:,j-1)+v(:,j);
end
stdIDIO=kron((std(er'))',ones(1,T));% Standardize
IDIOSYN=er./stdIDIO;
% Generate data
data=SYSTEM+IDIOSYN;
% Generate frequency domain data
% find fundamental frequency closest to theta
theta0=floor(theta*T/(2*pi));
% choose range of approximating frequencies
if m>floor(T/2)
    disp('decrease m')
end
if theta0-floor(m/2)<0
    theta_approx=[1:m];
elseif m-floor(m/2)+theta0>=floor(T/2)
    theta_approx=[floor(T/2)-m:floor(T/2)-1];
else
    theta_approx=[theta0-floor(m/2)+1:theta0-floor(m/2)+m];
end
% generate dft data
freqdata=data*exp(-sqrt(-1)*(1:T)'*(2*pi*theta_approx/T));
